#include	"curses.ext"

/*	box.c
 *
 *	Draw a box around the given window with "vert" as the vertical
 *	delimiting char-attribute, and "hor", as the horizontal one. 
 */

void
box(REG WINDOW *win,SHORT vert,SHORT hor )

	{ 
	REG INT i, j;
	INT endy, endx;
	SHORT *fp, *lp;
	SHORT use_lines;

	vert &= 0x00ff;
	hor  &= 0x00ff;
	
	if(hor == 0 || vert == 0){
		hor = term_state.box_horizontal;
		vert = term_state.box_vertical;
		use_lines =1;
		} 


	endx = win->_maxx;
	endy = win->_maxy - 1;
	fp = win->_y[0];
	lp = win->_y[endy];

	for (i = 0; i < endx; ++i)
		fp[i] = lp[i] = hor;
	--endx;

	for (i = 0; i <= endy; ++i)
		{
		win->_y[i][0] = win->_y[i][endx] = vert;
		for (j = 0; j <= endx; ++j)
			win->_y[i][j] = ((win->_y[i][j] & 0x00ff) | win->_attr );
		}
    if (use_lines == 1 ) {
        win->_y[0][0]       = term_state.box_top_left  | win->_attr ;
        win->_y[0][endx]    = term_state.box_top_right | win->_attr ;
        win->_y[endy][endx] = term_state.box_bot_right | win->_attr ;
        win->_y[endy][0]    = term_state.box_bot_left  | win->_attr ;
    	}

	if (!win->_scroll && (win->_flags&_SCROLLWIN))
		fp[0] = fp[endx] = lp[0] = lp[endx] = (_MTY_SPACE | _ATTR_NORMAL);


	touchwin( win );
	}
